<template>
  <div class="available-time">
    <div v-animate-css="'fadeIn'">
      <b-field
        grouped
        group-multiline>
        <p class="control"
          v-for="(time, index) in allAvailableHours"
          :key="index">
          <button class="button is-warning"
            :id="index"
            v-on:click="chooseTime($event, index)">
            {{ time.toLocaleTimeString('pt-br') }}
          </button>
        </p>
      </b-field>
    </div> <!-- animate -->
    <b-loading :is-full-page="false" :active.sync="isLoading" :can-cancel="false"></b-loading>
  </div>
</template>

<script>
export default {
  name: 'AvailableTime',
  props: {
    allDates: Array,
    dateTime: String,
    dateChoosed: Date,
  },
  data: function ()  {
    return {
      isLoading: false,
      choosenDate: new Date(),
      choosenTime: new Date(),
      timeChoosed: new Date(),
      choosenOldTime: '',
      choosenDateTime: new Date(),
      allAvailableHours: [],
    }
  },
  created () {
    this.allAvailableHours = []
    this.checkAvailableHours(this.dateChoosed)
  },
  components: {},
  methods: {
    chooseTime ($event, index) {
      if (this.choosenOldTime != '') {
        this.choosenOldTime.classList.add('is-warning')
        this.choosenOldTime.classList.remove('is-primary')
      }
      this.timeChoosed.setHours(this.allAvailableHours[index].getHours())
      this.timeChoosed.setMinutes(this.allAvailableHours[index].getMinutes())
      this.timeChoosed.setSeconds(0)
      var el = document.getElementById(index)
      el.classList.add('is-primary')
      el.classList.remove('is-warning')
      this.choosenOldTime = el
      this.$emit('timeChanged', this.timeChoosed)
    },
    checkAvailableHours (cd) {
      for (let key in this.allDates) {
        var aux = new Date(this.allDates[key])
        if (cd.getDate() == aux.getDate()) {
          this.allAvailableHours.push(aux)
        }
      }
    }
  },
  computed: {}
}
</script>
<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped lang="css">
</style>
